import { Extension, SDK } from '@commercetools/frontend-sdk';
import { ProjectActions } from './actions/ProjectActions.js';
import { ProductActions } from './actions/ProductActions.js';
import { CartActions } from './actions/CartActions.js';
import { WishlistActions } from './actions/WishlistActions.js';
import { AccountActions } from './actions/AccountActions.js';
import { ComposableCommerceEvents } from '../types/types.js';
import '../types/actions/ProjectActions.js';
import '@commercetools/frontend-domain-types/ProjectSettings';
import '../types/actions/ProductActions.js';
import '../types/queries/ProductQueries.js';
import '@commercetools/frontend-domain-types/query';
import '@commercetools/frontend-domain-types/product';
import '../types/actions/CartActions.js';
import '@commercetools/frontend-domain-types/cart';
import '../types/payloads/CartPayloads.js';
import '@commercetools/frontend-domain-types/account';
import '../types/actions/WishlistActions.js';
import '@commercetools/frontend-domain-types/wishlist';
import '../types/payloads/WishlistPayloads.js';
import '../types/actions/AccountActions.js';
import '../types/payloads/AccountPayloads.js';

declare class ComposableCommerce extends Extension<ComposableCommerceEvents> {
    constructor(sdk: SDK<ComposableCommerceEvents>);
    unregisterExtension(): void;
    project: ProjectActions;
    product: ProductActions;
    cart: CartActions;
    wishlist: WishlistActions;
    account: AccountActions;
}

export { ComposableCommerce };
