import { SDK } from '@commercetools/frontend-sdk';
import { GetAccountAction, LoginAccountAction, LogoutAccountAction, RegisterAccountAction, ConfirmAccountAction, RequestAccountConfirmationEmailAction, ChangeAccountPasswordAction, RequestAccountPasswordResetAction, ResetAccountPasswordAction, UpdateAccountAction, AddAccountAddressAction, UpdateAccountAddressAction, RemoveAccountAddressAction, SetDefaultAccountBillingAddressAction, SetDefaultAccountShippingAddressAction } from '../../types/actions/AccountActions.js';
import { ComposableCommerceEvents } from '../../types/types.js';
import '@commercetools/frontend-domain-types/account';
import '../../types/payloads/AccountPayloads.js';

type AccountActions = {
    getAccount: GetAccountAction;
    login: LoginAccountAction;
    logout: LogoutAccountAction;
    register: RegisterAccountAction;
    confirm: ConfirmAccountAction;
    requestConfirmationEmail: RequestAccountConfirmationEmailAction;
    changePassword: ChangeAccountPasswordAction;
    requestResetPassword: RequestAccountPasswordResetAction;
    resetPassword: ResetAccountPasswordAction;
    updateAccount: UpdateAccountAction;
    addAddress: AddAccountAddressAction;
    updateAddress: UpdateAccountAddressAction;
    removeAddress: RemoveAccountAddressAction;
    setDefaultBillingAddress: SetDefaultAccountBillingAddressAction;
    setDefaultShippingAddress: SetDefaultAccountShippingAddressAction;
};
declare const getAccountActions: (sdk: SDK<ComposableCommerceEvents>) => AccountActions;

export { AccountActions, getAccountActions };
