import { SDK } from '@commercetools/frontend-sdk';
import { GetCartAction, AddCartItemAction, RemoveCartItemAction, UpdateCartItemAction, UpdateCartAction, GetCartShippingMethodsAction, GetAvailableCartShippingMethodsAction, SetCartShippingMethodAction, RedeemDiscountCodeAction, RemoveDiscountCodeAction, CheckoutCartAction, GetOrderHistoryAction } from '../../types/actions/CartActions.js';
import { ComposableCommerceEvents } from '../../types/types.js';
import '@commercetools/frontend-domain-types/cart';
import '../../types/payloads/CartPayloads.js';
import '@commercetools/frontend-domain-types/account';

type CartActions = {
    getCart: GetCartAction;
    addItem: AddCartItemAction;
    removeItem: RemoveCartItemAction;
    updateItem: UpdateCartItemAction;
    updateCart: UpdateCartAction;
    getShippingMethods: GetCartShippingMethodsAction;
    getAvailableShippingMethods: GetAvailableCartShippingMethodsAction;
    setShippingMethod: SetCartShippingMethodAction;
    redeemDiscountCode: RedeemDiscountCodeAction;
    removeDiscountCode: RemoveDiscountCodeAction;
    checkout: CheckoutCartAction;
    getOrderHistory: GetOrderHistoryAction;
};
declare const getCartActions: (sdk: SDK<ComposableCommerceEvents>) => CartActions;

export { CartActions, getCartActions };
