import { SDK } from '@commercetools/frontend-sdk';
import { GetProductAction, ProductQueryAction, QueryProductCategoriesAction, GetSearchableProductAttributesAction } from '../../types/actions/ProductActions.js';
import { ComposableCommerceEvents } from '../../types/types.js';
import '../../types/queries/ProductQueries.js';
import '@commercetools/frontend-domain-types/query';
import '@commercetools/frontend-domain-types/product';

type ProductActions = {
    getProduct: GetProductAction;
    query: ProductQueryAction;
    queryCategories: QueryProductCategoriesAction;
    getSearchableAttributes: GetSearchableProductAttributesAction;
};
declare const getProductActions: (sdk: SDK<ComposableCommerceEvents>) => ProductActions;

export { ProductActions, getProductActions };
