import { SDK } from '@commercetools/frontend-sdk';
import { GetWishlistAction, AddToWishlistAction, RemoveFromWishlistAction, UpdateWishlistItemAction } from '../../types/actions/WishlistActions.js';
import { ComposableCommerceEvents } from '../../types/types.js';
import '@commercetools/frontend-domain-types/wishlist';
import '../../types/payloads/WishlistPayloads.js';

type WishlistActions = {
    getWishlist: GetWishlistAction;
    addItem: AddToWishlistAction;
    removeItem: RemoveFromWishlistAction;
    updateItem: UpdateWishlistItemAction;
};
declare const getWishlistActions: (sdk: SDK<ComposableCommerceEvents>) => WishlistActions;

export { WishlistActions, getWishlistActions };
