import { GetProductQuery, ProductQueryQuery, QueryProductCategoriesQuery } from '../queries/ProductQueries.js';
import { Product, Result, FilterField } from '@commercetools/frontend-domain-types/product';
import { ServerOptions, SDKResponse } from '@commercetools/frontend-sdk';
import '@commercetools/frontend-domain-types/query';

type GetProductAction = (query: GetProductQuery, options?: {
    serverOptions?: ServerOptions;
}) => Promise<SDKResponse<Product>>;
type ProductQueryAction = (query: ProductQueryQuery, options?: {
    serverOptions?: ServerOptions;
}) => Promise<SDKResponse<Result>>;
type QueryProductCategoriesAction = (query: QueryProductCategoriesQuery, options?: {
    serverOptions?: ServerOptions;
}) => Promise<SDKResponse<Result>>;
type GetSearchableProductAttributesAction = (options?: {
    serverOptions?: ServerOptions;
}) => Promise<SDKResponse<FilterField[]>>;

export { GetProductAction, GetSearchableProductAttributesAction, ProductQueryAction, QueryProductCategoriesAction };
