import { Address } from '@commercetools/frontend-domain-types/account';

type AddCartItemPayload = {
    variant: {
        sku: string;
        count: number;
    };
};
type RemoveCartItemPayload = {
    lineItem: {
        id: string;
    };
};
type UpdateCartItemPayload = {
    lineItem: {
        id: string;
        count: number;
    };
};
type UpdateCartPayload = {
    account?: {
        email: string;
    };
    shipping?: Address;
    billing?: Address;
};
type GetCartShippingMethodsPayload = {
    query: {
        onlyMatching: boolean;
    };
};
type SetCartShippingMethodPayload = {
    shippingMethod: {
        id: string;
    };
};
type RedeemDiscountCodePayload = {
    code: string;
};
type RemoveDiscountCodePayload = {
    discountId: string;
};

export { AddCartItemPayload, GetCartShippingMethodsPayload, RedeemDiscountCodePayload, RemoveCartItemPayload, RemoveDiscountCodePayload, SetCartShippingMethodPayload, UpdateCartItemPayload, UpdateCartPayload };
